hdu 6092 Rikka with Subset【01背包+思维】

来源:互联网 发布:淘宝支付宝账号怎么改 编辑:程序博客网 时间:2024/06/05 09:43

Rikka with Subset

Problem Description
As we know, Rikka is poor at math. Yuta is worrying about this situation, so he gives Rikka some math tasks to practice. There is one of them:

Yuta has n positive A1−An and their sum is m. Then for each subset S of A, Yuta calculates the sum of S.

Now, Yuta has got 2n numbers between [0,m]. For each i∈[0,m], he counts the number of is he got as Bi.

Yuta shows Rikka the array Bi and he wants Rikka to restore A1−An.

It is too difficult for Rikka. Can you help her?

Input
The first line contains a number t(1≤t≤70), the number of the testcases.

For each testcase, the first line contains two numbers n,m(1≤n≤50,1≤m≤104).

The second line contains m+1 numbers B0−Bm(0≤Bi≤2n).

Output
For each testcase, print a single line with n numbers A1−An.

It is guaranteed that there exists at least one solution. And if there are different solutions, print the lexicographic minimum one.

Sample Input
2
2 3
1 1 1 1
3 3
1 3 3 1

Sample Output
1 2
1 1 1
Hint

In the first sample, A is [1,2]. A has four subsets [],[1],[2],[1,2] and the sums of each subset are 0,1,2,3. So B=[1,1,1,1]
题意:
T组测试,接下来一行n和m,下面一行m+1个数字代表B(0~m)求A序列,Bi 代表A序列中的所有子集之和为i的有Bi个,A序列总和为m,n个元素;
思路:
分析:很多个较小的数字随机组合会求出多个很大的数字,所以从B0向Bm推导,在每求出A序列的一部分这个过程中,更新后续的B序列,更新完的B[i]就是 i 在A序列中出现的次数。
分析完后,主要的难点就是怎么去让已求出来的A序列随机组合,更新后续的B序列直接减就可以了。看成01背包问题,让m为背包去装 i,初始值为dp[0] = 1,由于i依次增大,A子集随机组合不会重复,over;

#include <cstdio>#include <cstring>#include <algorithm>#include <cmath>#define max_n 10010using namespace std;int a[max_n], b[max_n], dp[max_n], c[max_n];//dp[i]表示:加和为i的子集个数;int main() {    int t, n, m;    scanf("%d", &t);    while(t--) {        memset(a, 0, sizeof(a));        memset(b, 0, sizeof(b));        memset(dp, 0, sizeof(dp));        scanf("%d %d", &n, &m);        for(int i = 0; i <= m; i++)            scanf("%d", &b[i]);        dp[0] = 1; //初始化值        int p = 0, sum = 0;        for(int i = 1; i <= m; i++) {            c[i] = b[i] - dp[i];//A序列中值为i的个数            for(int j = 0; j < c[i]; j++) {                a[p++] = i; //对A序列赋值                for(int k = m; k>= i; k--) { //处理成01背包                     dp[k] += dp[k - i]; //和为k的A子集个数相加去更新B序列                }            }        }        for(int i = 0; i < p; i++) {            if(i > 0) printf(" ");            printf("%d", a[i]);//输出A序列        }        printf("\n");    }    return 0;}
原创粉丝点击